Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.5-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Name:           google-collections
Version:        0.7
Release:        alt1_1jpp5
Epoch:          0
Summary:        Google Collections Library
License:        ASL 2.0
Group:          Development/Java
URL:            http://code.google.com/p/google-collections/
# svn export -r20080530 http://google-collections.googlecode.com/svn/trunk/ google-collections-0.7
# tar cjf google-collections-0.7.tar.bz2 google-collections-0.7
Source0:        http://google-collections.googlecode.com/files/google-collections-0.7.tar.bz2
Source1:        google-collections.pom
Patch0:         google-collections-javadoc-crosslink.patch
Provides:       google-collect = %{epoch}:%{version}-%{release}
Requires: jpackage-utils
BuildRequires: ant
BuildRequires: java-javadoc
BuildRequires: jpackage-utils
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
%else
Buildarch:      noarch
%endif

%description
The Google Collections Library 0.7 (ALPHA) is a suite of new collections and
collection-related goodness for Java 5.0, brought to you by Google.

This library is a natural extension of the Java Collections Framework you
already know and love.

The major new types are:

    * BiMap. A Map that guarantees unique values, and supports an inverse view.
    * Multiset. A Collection that may contain duplicate values like a List, yet
      has order-independent equality like a Set. Often used to represent a
      histogram.
    * Multimap. Similar to Map, but may contain duplicate keys. Has subtypes
      SetMultimap and ListMultimap providing more specific behavior. 

There are also more than a dozen collection implementations, mostly of the
interfaces above, but not all. ReferenceMap, for example, is a ConcurrentMap
implementation which easily handles any combination of strong, soft or weak
keys with strong, soft or weak values.

Static utility classes include:

    * Comparators. Natural order, compound, null-friendly, ad-hoc . . .
    * Iterators and Iterables. Element-based equality, cycle, concat,
      partition, filter with predicate, transform with function . . .
    * Lists, Sets and Maps. A plethora of convenient factory methods and much
      more.
    * PrimitiveArrays: "boxing"/"unboxing" of primitive arrays 

And there's more:

    * Forwarding collections
    * Constrained collections
    * Implementation helpers like AbstractIterator 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q
%patch0 -p1

%build
export OPT_JAR_LIST=:
export CLASSPATH=
%{ant} -Dversion=%{version} jar javadoc

%install

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -a build/dist/google-collect-%{version}/google-collect-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%{__ln_s} %{name}-%{version}.jar %{buildroot}%{_javadir}/google-collect-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} ${jar/-%{version}/}; done)

# poms
%add_to_maven_depmap com.google.code.google-collections %{name} %{version} JPP %{name}

%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -a %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}.pom

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db || :
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db || :
fi
%endif

%files
%doc COPYING
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/google-collect-%{version}.jar
%{_javadir}/google-collect.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sat Sep 06 2008 Igor Vlasenko <viy@altlinux.ru> 0:0.7-alt1_1jpp5
- converted from JPackage by jppimport script

